import re
import subprocess

libpfm4 = '/home/jan/Projects/libpfm4/examples'

codes_regex = re.compile('Codes\s+:\s?([a-zA-Z0-9]+)')

events_result = subprocess.run([f'{libpfm4}/showevtinfo'], stdout=subprocess.PIPE)
counters = []

def extract_events(content: str):
    # Find the event name
    name_match = re.search(r"Name\s+:\s+([a-zA-Z0-9\_\-]+)", content)
    if not name_match:
        return []
    event_name = name_match.group(1)

    # Find all Umask entries and their descriptions
    umask_matches = re.findall(r"Umask-\d+\s+:\s+0x[0-9a-fA-F]+\s+:\s+PMU\s+:\s+\[(.*?)\]", content)

    if not umask_matches:
        return [event_name]

    # Combine the event name with each Umask
    return [f"{event_name}.{umask.replace(' ', '_')}" for umask in umask_matches]


for events_content in str(events_result.stdout).split('#-----------------------------'):
    events = extract_events(events_content)
    for event_to_check in events:
        event_result = subprocess.run([f'{libpfm4}/check_events', event_to_check], stdout=subprocess.PIPE)
        codes_match = re.search(r"Codes\s+:\s+(0x[0-9a-fA-F]+)", str(event_result.stdout))

        if codes_match:
            counters.append((event_to_check, codes_match.group(1)))
        #for event_line in str(event_result.stdout).split('\\n'):
        #    codes_match = codes_regex.match(event_line)
        #    if codes_match and codes_match[1] != "0x0" and len(codes_match[1]) > 7:
        #        counters.append((event_to_check, codes_match[1]))

    '''
    event_name = None
    umasks = []
    for line in event.split('\\n'):
        event_name_match = event_name_regex.match(line)
        if event_name_match:
            event_name = event_name_match[1]
        else:
            umask_match = umask_regex.match(line)
            if umask_match:
                umasks.append((umask_match[1], umask_match[2]))
                
    if event_name:
        events_to_check = [event_name] if len(umasks) == 0 else [f'{event_name}.{umask[1]}' for umask in umasks]

        for event_to_check in events_to_check:
            event_result = subprocess.run([f'{libpfm4}/check_events', event_to_check], stdout=subprocess.PIPE)
            for event_line in str(event_result.stdout).split('\\n'):
                codes_match = codes_regex.match(event_line)
                if codes_match and codes_match[1] != "0x0" and len(codes_match[1]) > 7:
                    counters.append((event_to_check, codes_match[1]))
    '''

with open('perf.csv', 'w') as perf_out_file:
    for counter in counters:
        perf_out_file.write(f'{counter[0]},{counter[1]}\n')
    
print(f'Wrote {len(counters)} counter definitions.')

