#!/bin/bash

# Define the base directory to search in
BASE_DIR="plots/"

clean_pdf_files() {
    folder="$1"
    echo "Removing all PDF files in folder: $folder and its subfolders"
    find "$folder" -type f -name "*.pdf" -exec rm -f {} +
}

plot() {
  # Find all 'out.csv' files under the base directory and loop through them
  find "$1" -type f -name "out.csv" | while read -r file; do
    echo "## Processing $file"
    python3 script/analyze.py --in "$file"
    python3 script/plot-cost.py --in "$file"
  done

  echo "## Processing Trend"
  python3 script/plot-trend.py
}

if [ $# -eq 0 ]; then
    plot "$BASE_DIR"
    exit 0
fi

# Check if the provided string is "clean"
if [ "$1" = "clean" ]; then
    clean_pdf_files "$BASE_DIR"
else
    echo "String does not match 'clean'. No action taken."
fi