#pragma once
#include <cstdint>
#include <new>
#include <thread>

namespace swprf
{
class config
{
public:
#if defined(__cpp_lib_hardware_interference_size)
    static constexpr std::size_t cache_line_size = std::hardware_constructive_interference_size;
#elif defined(CACHE_LINE_SIZE)
        static constexpr std::size_t cache_line_size = CACHE_LINE_SIZE;
#else
    static constexpr std::size_t cache_line_size = 64;
#endif
};
}